package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.GoodsBatch;
import com.ff.weijinxiao.repository.GoodsBatchRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class GoodsBatchService {

    @Resource
    private GoodsBatchRepository goodsBatchRepository;

    /**
     * 创建实体
     *
     * @param goodsBatch
     */
    public GoodsBatch saveGoodsBatch(GoodsBatch goodsBatch) {
        return goodsBatchRepository.save(goodsBatch);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public GoodsBatch findById(Integer id) {
        Optional<GoodsBatch> optional = goodsBatchRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public GoodsBatch findByOnlyID(String onlyID) {
        return goodsBatchRepository.findByOnlyID(onlyID);
    }

    public void deleteById(Integer id) {
        goodsBatchRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<GoodsBatch> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return goodsBatchRepository.findAll(SpecificationUtil.buildSpecification(param, GoodsBatch.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<GoodsBatch> findList(Map<String, Object> param) {
        return goodsBatchRepository.findAll(SpecificationUtil.buildSpecification(param, GoodsBatch.class));
    }

}
